#ifndef MYCANVASVIEW_H
#define MYCANVASVIEW_H

#include "grobj.h"
#include <qcanvas.h>
#include <list>
#include "vertex_array.H"
using namespace gtl;
using namespace std;

enum opntype { nopn, newline, newcircle, moveopn, rotateopn, scaleopn, stretchopn };

class QStatusBar;
class QCanvasItemList;

class MyCanvasView: public QCanvasView
{
    Q_OBJECT

public:
    MyCanvasView ( QCanvas *canvas, QWidget * parent = 0, const char * name = 0, WFlags f = 0 );
    ~MyCanvasView();

protected:
    void MyCanvasView::contentsMousePressEvent( QMouseEvent* e );
    void MyCanvasView::contentsMouseReleaseEvent( QMouseEvent* e );
    void MyCanvasView::contentsMouseMoveEvent( QMouseEvent* e );


public slots:
    void line();
    void circle();

    void move();
    void rotate();
    void scale();
    void stretch();

private:
    list<Grobj*> objlist;
    list<Grobj*>::iterator objit;    
    QStatusBar *status;
    opntype activeopn;
    Grobj *activeobj;
    bool activeinlist;
    vector<vertex<int> > opnpts;
};


#endif
