#ifndef _GTL_VERTEX_ARRAY
#define _GTL_VERTEX_ARRAY

#include "vertex.H"
#include <vector>

namespace gtl
{

template <class T=long double>
class vertex_array
  {
  protected:
    std::vector<vertex<T> > vertices;
  public:
    typedef vertex<T> element_type;
    typedef typename std::vector<vertex<T> >::iterator iterator;
    iterator begin() { return vertices.begin(); }
    iterator end() { return vertices.end(); }

    vertex_array operator+=(const vertex<T>& v)
      { this->vertices.push_back(v); return *this; }
    
    int size()
      { return vertices.size(); }
    
    void clear()
      { vertices.clear(); }

    friend std::ostream& operator<<(std::ostream& os, const vertex_array& va)
      { 
        os << "|" ;
        if (va.vertices.size()>0) os << va.vertices[0];
        for (int i=1; i<va.vertices.size(); i++) os << "," << va.vertices[i];
        return os << "|";
      }

  };

} // namespace gtl

#endif // _GTL_VERTEX_ARRAY
